#include <windows.h>
#include "CommandProcessor.h"
#include <iostream>
#include <string>
#include <shlwapi.h>
#include <shlobj.h>

using namespace std;

void CommandProcessor::ProcessInput(const wchar_t *text)
{
	wcout << L"<" << text << L">" << endl;
	const wchar_t echoCmd[] = L"echo ";
	const wchar_t openCmd[] = L"open ";

	if (!wcsncmp(text, openCmd, ARRAYSIZE(openCmd) - 1))
	{
		Open(text + ARRAYSIZE(openCmd) - 1);
	}
	else
	{
		wcerr << L"Unknown command." << endl;
	}
}

void CommandProcessor::Open(const wchar_t *text)
{
	if (wcslen(text) < MAX_PATH)
	{
		OPENASINFO openAsInfo;
		openAsInfo.pcszFile = text;
		openAsInfo.oaifInFlags = OAIF_HIDE_REGISTRATION | OAIF_EXEC;
		openAsInfo.pcszClass = NULL;

		HRESULT hr = SHOpenWithDialog(NULL, &openAsInfo);
		if (FAILED(hr))
		{
			wcerr << L"SHOpenWithDialog Error: 0x" << hex << hr << endl;
		}
	}
	else
	{
		wcerr << L"Open request too long." << endl;
	}
}