#pragma once
#include <list>
class Connection;

class NetComm
{
public:
	NetComm() { InitNetwork(); }
	~NetComm() { UninitNetwork(); }

	void ListenForConnections(const wchar_t *port);
	Connection* ConnectTo(const wchar_t *hostname, const wchar_t *port);
	void AddAcceptableClient(const wchar_t *clientName);

protected:
	std::list<std::wstring> mClientNameList;

	bool IsAcceptableClient(const sockaddr *clientAddress) const;

	static int InitNetwork();
	static void UninitNetwork();

private:
	NetComm(const NetComm&);
	const NetComm &operator=(const NetComm&);
};
